﻿using System;
using System.Text;
using System.Text.RegularExpressions;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections;
using System.Collections.Generic;

namespace SOAP_Folders_PreSave
{
   class Folder_PreSave
   {
      static int Main(string[] args)
      {
         int nReturn = 0;

         try
         {
            // Validate that the defect has at least one hashtag
            List<string> tags = GetHashTagsFromString(Environment.GetEnvironmentVariable("SUMM"));
            int rprtByNum = 1;
            string comments = Environment.GetEnvironmentVariable("DESC" + rprtByNum);
            while (comments != null)
            {
            	tags.AddRange(GetHashTagsFromString(comments));
                rprtByNum++;
                comments = Environment.GetEnvironmentVariable("DESC" + rprtByNum);
            }
            
            if (tags.Count == 0)
            {
            	Console.WriteLine("Defects must contain at least one #hash tag in the summary or description.");
                nReturn = 1;
            }
         }
         catch (Exception e)
         {
            Console.WriteLine(e.ToString());
            nReturn = 1;
         }

         return nReturn;
      }

      private static List<string> GetHashTagsFromString(string str)
      {
         List<string> tags = new List<string>();
      
         if (str != null)
         {
            Regex exp = new Regex(@"#\w+\b");
            MatchCollection matches = exp.Matches(str);
      
            foreach (Match match in matches)
            {
               tags.Add(str.Substring(match.Index, match.Length));
            }
         }
      
         return tags;
      }

   }
}
